#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

/* On change le signal SIGQUIT  SIGTSTP */
/* ... car le dernier ne marche pas sur les machines SUN  */
#define MONSIGNAL SIGTSTP

static char command[100];
static pid_t monpid,pid;

void interruption(int signum)
{
  printf("[%d] Ping !!!\n",getpid());
  printf("\tLe signal %d est envoi au processus %d.\n",
	 MONSIGNAL,pid);
#ifndef APPSYSTEME
  system(command); 
#else 
  kill(pid,MONSIGNAL); 
#endif
}

int main(void)
{
  int retcode; 
  struct sigaction action;
  
  monpid=getpid();
  /*  Recuperation de CRTL-Z */
  action.sa_handler=interruption;
  action.sa_flags=0;
  sigemptyset(&action.sa_mask);
  sigaction(MONSIGNAL,&action,NULL);  

#ifndef APPSYSTEME
  do 
    {
      printf("[%d] : Rentrez le numro du processus : ",monpid);
      fflush(stdout);
      retcode = scanf("%d",&pid);
    }
  while(retcode != 1);
  sprintf(command,"kill -%d %d",MONSIGNAL,pid);
#endif

  for(;;) sleep(1);
  /* On ne sort jamais par ici */
  return EXIT_SUCCESS;
}
